diff --git a/arch/blackfin/config.mk b/arch/blackfin/config.mk
index ab117ca..ae9d987 100644
--- a/arch/blackfin/config.mk
+++ b/arch/blackfin/config.mk
@@ -69,3 +69,7 @@ LDR_FLAGS += $(LDR_FLAGS-y)
 ifeq ($(wildcard $(TOPDIR)/board/$(BOARD)/u-boot.lds*),)
 LDSCRIPT = $(obj)arch/$(ARCH)/lib/u-boot.lds.S
 endif
+
+ifneq ($(CONFIG_SYS_TEXT_BASE),)
+$(error do not set CONFIG_SYS_TEXT_BASE for Blackfin boards)
+endif
diff --git a/board/bct-brettl2/config.mk b/board/bct-brettl2/config.mk
index 0c02d44..df11d61 100644
--- a/board/bct-brettl2/config.mk
+++ b/board/bct-brettl2/config.mk
@@ -23,9 +23,6 @@
 # MA 02111-1307 USA
 #
 
-# This is not actually used for Blackfin boards so do not change it
-#CONFIG_SYS_TEXT_BASE = do-not-use-me
-
 CONFIG_BFIN_CPU = bf536-0.3
 
 CFLAGS_lib += -O2
diff --git a/board/bf518f-ezbrd/config.mk b/board/bf518f-ezbrd/config.mk
index 9a54dbf..7664261 100644
--- a/board/bf518f-ezbrd/config.mk
+++ b/board/bf518f-ezbrd/config.mk
@@ -23,9 +23,6 @@
 # MA 02111-1307 USA
 #
 
-# This is not actually used for Blackfin boards so do not change it
-#CONFIG_SYS_TEXT_BASE = do-not-use-me
-
 CONFIG_BFIN_CPU = bf518-0.0
 
 CFLAGS_lib += -O2
diff --git a/board/bf526-ezbrd/config.mk b/board/bf526-ezbrd/config.mk
index 46c09ea..60f6f9c 100644
--- a/board/bf526-ezbrd/config.mk
+++ b/board/bf526-ezbrd/config.mk
@@ -23,9 +23,6 @@
 # MA 02111-1307 USA
 #
 
-# This is not actually used for Blackfin boards so do not change it
-#CONFIG_SYS_TEXT_BASE = do-not-use-me
-
 CONFIG_BFIN_CPU = bf526-0.0
 
 CFLAGS_lib += -O2
diff --git a/board/bf527-ad7160-eval/config.mk b/board/bf527-ad7160-eval/config.mk
index a6c272a..ecb31bf 100644
--- a/board/bf527-ad7160-eval/config.mk
+++ b/board/bf527-ad7160-eval/config.mk
@@ -23,9 +23,6 @@
 # MA 02111-1307 USA
 #
 
-# This is not actually used for Blackfin boards so do not change it
-#CONFIG_SYS_TEXT_BASE = do-not-use-me
-
 CONFIG_BFIN_CPU = bf527-0.2
 
 CFLAGS_lib += -O2
diff --git a/board/bf527-ezkit/config.mk b/board/bf527-ezkit/config.mk
index 790fe99..436a7b3 100644
--- a/board/bf527-ezkit/config.mk
+++ b/board/bf527-ezkit/config.mk
@@ -23,9 +23,6 @@
 # MA 02111-1307 USA
 #
 
-# This is not actually used for Blackfin boards so do not change it
-#CONFIG_SYS_TEXT_BASE = do-not-use-me
-
 CONFIG_BFIN_CPU = bf527-0.0
 
 CFLAGS_lib += -O2
diff --git a/board/bf527-sdp/config.mk b/board/bf527-sdp/config.mk
index 7cb935a..8eff4fd 100644
--- a/board/bf527-sdp/config.mk
+++ b/board/bf527-sdp/config.mk
@@ -23,9 +23,6 @@
 # MA 02111-1307 USA
 #
 
-# This is not actually used for Blackfin boards so do not change it
-#CONFIG_SYS_TEXT_BASE = do-not-use-me
-
 CONFIG_BFIN_CPU = bf527-0.2
 
 CFLAGS_lib_generic += -O2
diff --git a/board/bf533-ezkit/config.mk b/board/bf533-ezkit/config.mk
index a0d1749..c775398 100644
--- a/board/bf533-ezkit/config.mk
+++ b/board/bf533-ezkit/config.mk
@@ -23,9 +23,6 @@
 # MA 02111-1307 USA
 #
 
-# This is not actually used for Blackfin boards so do not change it
-#CONFIG_SYS_TEXT_BASE = do-not-use-me
-
 CONFIG_BFIN_CPU = bf533-0.3
 
 CFLAGS_lib += -O2
diff --git a/board/bf533-stamp/config.mk b/board/bf533-stamp/config.mk
index a0d1749..c775398 100644
--- a/board/bf533-stamp/config.mk
+++ b/board/bf533-stamp/config.mk
@@ -23,9 +23,6 @@
 # MA 02111-1307 USA
 #
 
-# This is not actually used for Blackfin boards so do not change it
-#CONFIG_SYS_TEXT_BASE = do-not-use-me
-
 CONFIG_BFIN_CPU = bf533-0.3
 
 CFLAGS_lib += -O2
diff --git a/board/bf537-minotaur/config.mk b/board/bf537-minotaur/config.mk
index de02635..0f0ed48 100644
--- a/board/bf537-minotaur/config.mk
+++ b/board/bf537-minotaur/config.mk
@@ -23,9 +23,6 @@
 # MA 02111-1307 USA
 #
 
-# This is not actually used for Blackfin boards so do not change it
-#CONFIG_SYS_TEXT_BASE = do-not-use-me
-
 CONFIG_BFIN_CPU = bf537-0.2
 
 # Set some default LDR flags based on boot mode.
diff --git a/board/bf537-pnav/config.mk b/board/bf537-pnav/config.mk
index e29d87f..1e7afcc 100644
--- a/board/bf537-pnav/config.mk
+++ b/board/bf537-pnav/config.mk
@@ -23,9 +23,6 @@
 # MA 02111-1307 USA
 #
 
-# This is not actually used for Blackfin boards so do not change it
-#CONFIG_SYS_TEXT_BASE = do-not-use-me
-
 CONFIG_BFIN_CPU = bf537-0.2
 
 # Set some default LDR flags based on boot mode.
diff --git a/board/bf537-srv1/config.mk b/board/bf537-srv1/config.mk
index de02635..0f0ed48 100644
--- a/board/bf537-srv1/config.mk
+++ b/board/bf537-srv1/config.mk
@@ -23,9 +23,6 @@
 # MA 02111-1307 USA
 #
 
-# This is not actually used for Blackfin boards so do not change it
-#CONFIG_SYS_TEXT_BASE = do-not-use-me
-
 CONFIG_BFIN_CPU = bf537-0.2
 
 # Set some default LDR flags based on boot mode.
diff --git a/board/bf537-stamp/config.mk b/board/bf537-stamp/config.mk
index 6694f06..f913f9a 100644
--- a/board/bf537-stamp/config.mk
+++ b/board/bf537-stamp/config.mk
@@ -23,9 +23,6 @@
 # MA 02111-1307 USA
 #
 
-# This is not actually used for Blackfin boards so do not change it
-#CONFIG_SYS_TEXT_BASE = do-not-use-me
-
 CONFIG_BFIN_CPU = bf537-0.2
 
 CFLAGS_lib += -O2
diff --git a/board/bf538f-ezkit/config.mk b/board/bf538f-ezkit/config.mk
index 4ab1397..2644021 100644
--- a/board/bf538f-ezkit/config.mk
+++ b/board/bf538f-ezkit/config.mk
@@ -23,9 +23,6 @@
 # MA 02111-1307 USA
 #
 
-# This is not actually used for Blackfin boards so do not change it
-#CONFIG_SYS_TEXT_BASE = do-not-use-me
-
 CONFIG_BFIN_CPU = bf538-0.4
 
 CFLAGS_lib += -O2
diff --git a/board/bf548-ezkit/config.mk b/board/bf548-ezkit/config.mk
index 9aa1761..b7f91f2 100644
--- a/board/bf548-ezkit/config.mk
+++ b/board/bf548-ezkit/config.mk
@@ -23,9 +23,6 @@
 # MA 02111-1307 USA
 #
 
-# This is not actually used for Blackfin boards so do not change it
-#CONFIG_SYS_TEXT_BASE = do-not-use-me
-
 CONFIG_BFIN_CPU = bf548-0.0
 
 CFLAGS_lib += -O2
diff --git a/board/bf561-acvilon/config.mk b/board/bf561-acvilon/config.mk
index 5c88114..20c1ec2f 100644
--- a/board/bf561-acvilon/config.mk
+++ b/board/bf561-acvilon/config.mk
@@ -23,9 +23,6 @@
 # MA 02111-1307 USA
 #
 
-# This is not actually used for Blackfin boards so do not change it
-#CONFIG_SYS_TEXT_BASE = do-not-use-me
-
 CONFIG_BFIN_CPU = bf561-0.5
 
 CFLAGS_lib += -O2
diff --git a/board/bf561-ezkit/config.mk b/board/bf561-ezkit/config.mk
index 19cdefc..db92eec 100644
--- a/board/bf561-ezkit/config.mk
+++ b/board/bf561-ezkit/config.mk
@@ -23,9 +23,6 @@
 # MA 02111-1307 USA
 #
 
-# This is not actually used for Blackfin boards so do not change it
-#CONFIG_SYS_TEXT_BASE = do-not-use-me
-
 CONFIG_BFIN_CPU = bf561-0.3
 
 CFLAGS_lib += -O2
diff --git a/board/blackstamp/config.mk b/board/blackstamp/config.mk
index 0ca3c90..083aff1 100644
--- a/board/blackstamp/config.mk
+++ b/board/blackstamp/config.mk
@@ -23,9 +23,6 @@
 # MA 02111-1307 USA
 #
 
-# This is not actually used for Blackfin boards so do not change it
-#CONFIG_SYS_TEXT_BASE = do-not-use-me
-
 CONFIG_BFIN_CPU = bf532-0.5
 
 # Set some default LDR flags based on boot mode.
diff --git a/board/blackvme/config.mk b/board/blackvme/config.mk
index 4d6e0ba..0400ace 100644
--- a/board/blackvme/config.mk
+++ b/board/blackvme/config.mk
@@ -23,9 +23,6 @@
 # MA 02111-1307 USA
 #
 
-# This is not actually used for Blackfin boards so do not change it
-#CONFIG_SYS_TEXT_BASE = do-not-use-me
-
 CONFIG_BFIN_CPU = bf561-0.5
 
 # Set some default LDR flags based on boot mode.
diff --git a/board/cm-bf527/config.mk b/board/cm-bf527/config.mk
index 790fe99..436a7b3 100644
--- a/board/cm-bf527/config.mk
+++ b/board/cm-bf527/config.mk
@@ -23,9 +23,6 @@
 # MA 02111-1307 USA
 #
 
-# This is not actually used for Blackfin boards so do not change it
-#CONFIG_SYS_TEXT_BASE = do-not-use-me
-
 CONFIG_BFIN_CPU = bf527-0.0
 
 CFLAGS_lib += -O2
diff --git a/board/cm-bf533/config.mk b/board/cm-bf533/config.mk
index a0d1749..c775398 100644
--- a/board/cm-bf533/config.mk
+++ b/board/cm-bf533/config.mk
@@ -23,9 +23,6 @@
 # MA 02111-1307 USA
 #
 
-# This is not actually used for Blackfin boards so do not change it
-#CONFIG_SYS_TEXT_BASE = do-not-use-me
-
 CONFIG_BFIN_CPU = bf533-0.3
 
 CFLAGS_lib += -O2
diff --git a/board/cm-bf537e/config.mk b/board/cm-bf537e/config.mk
index c5d45c7..36d8778 100644
--- a/board/cm-bf537e/config.mk
+++ b/board/cm-bf537e/config.mk
@@ -23,9 +23,6 @@
 # MA 02111-1307 USA
 #
 
-# This is not actually used for Blackfin boards so do not change it
-#CONFIG_SYS_TEXT_BASE = do-not-use-me
-
 CONFIG_BFIN_CPU = bf537-0.2
 
 CFLAGS_lib += -O2
diff --git a/board/cm-bf537u/config.mk b/board/cm-bf537u/config.mk
index c5d45c7..36d8778 100644
--- a/board/cm-bf537u/config.mk
+++ b/board/cm-bf537u/config.mk
@@ -23,9 +23,6 @@
 # MA 02111-1307 USA
 #
 
-# This is not actually used for Blackfin boards so do not change it
-#CONFIG_SYS_TEXT_BASE = do-not-use-me
-
 CONFIG_BFIN_CPU = bf537-0.2
 
 CFLAGS_lib += -O2
diff --git a/board/cm-bf548/config.mk b/board/cm-bf548/config.mk
index da6aa52..e1620e0 100644
--- a/board/cm-bf548/config.mk
+++ b/board/cm-bf548/config.mk
@@ -23,9 +23,6 @@
 # MA 02111-1307 USA
 #
 
-# This is not actually used for Blackfin boards so do not change it
-#CONFIG_SYS_TEXT_BASE = do-not-use-me
-
 CONFIG_BFIN_CPU = bf548-0.0
 
 CFLAGS_lib += -O2
diff --git a/board/cm-bf561/config.mk b/board/cm-bf561/config.mk
index 19cdefc..db92eec 100644
--- a/board/cm-bf561/config.mk
+++ b/board/cm-bf561/config.mk
@@ -23,9 +23,6 @@
 # MA 02111-1307 USA
 #
 
-# This is not actually used for Blackfin boards so do not change it
-#CONFIG_SYS_TEXT_BASE = do-not-use-me
-
 CONFIG_BFIN_CPU = bf561-0.3
 
 CFLAGS_lib += -O2
diff --git a/board/ibf-dsp561/config.mk b/board/ibf-dsp561/config.mk
index 80b527c..e213714 100644
--- a/board/ibf-dsp561/config.mk
+++ b/board/ibf-dsp561/config.mk
@@ -23,9 +23,6 @@
 # MA 02111-1307 USA
 #
 
-# This is not actually used for Blackfin boards so do not change it
-#CONFIG_SYS_TEXT_BASE = do-not-use-me
-
 CONFIG_BFIN_CPU = bf561-0.5
 
 # Set some default LDR flags based on boot mode.
diff --git a/board/ip04/config.mk b/board/ip04/config.mk
index fc818fb..0722a96 100644
--- a/board/ip04/config.mk
+++ b/board/ip04/config.mk
@@ -23,9 +23,6 @@
 # MA 02111-1307 USA
 #
 
-# This is not actually used for Blackfin boards so do not change it
-#CONFIG_SYS_TEXT_BASE = do-not-use-me
-
 CONFIG_BFIN_CPU = bf532-0.5
 
 CFLAGS_lib += -O2
diff --git a/board/tcm-bf518/config.mk b/board/tcm-bf518/config.mk
index 9a54dbf..7664261 100644
--- a/board/tcm-bf518/config.mk
+++ b/board/tcm-bf518/config.mk
@@ -23,9 +23,6 @@
 # MA 02111-1307 USA
 #
 
-# This is not actually used for Blackfin boards so do not change it
-#CONFIG_SYS_TEXT_BASE = do-not-use-me
-
 CONFIG_BFIN_CPU = bf518-0.0
 
 CFLAGS_lib += -O2
diff --git a/board/tcm-bf537/config.mk b/board/tcm-bf537/config.mk
index c5d45c7..36d8778 100644
--- a/board/tcm-bf537/config.mk
+++ b/board/tcm-bf537/config.mk
@@ -23,9 +23,6 @@
 # MA 02111-1307 USA
 #
 
-# This is not actually used for Blackfin boards so do not change it
-#CONFIG_SYS_TEXT_BASE = do-not-use-me
-
 CONFIG_BFIN_CPU = bf537-0.2
 
 CFLAGS_lib += -O2